unit Unit10;

interface

uses
  Classes, SysUtils, IWAppForm, IWApplication, IWColor, IWTypes,
  Vcl.Controls, IWVCLBaseControl, IWBaseControl, IWBaseHTMLControl, IWControl,
  IWCompLabel, IWCompListbox, IWCompButton, IWCompEdit, IWCompCheckbox,
  IWPayPalClient, ServerController, IWBaseComponent, IWBaseHTMLComponent,
  IWBaseHTML40Component, IWTMSAuthBase, Windows, IWExtCtrls;

type
  TIWForm10 = class(TIWAppForm)
    IWLabel5: TIWLabel;
    IWImageFile1: TIWImageFile;
    lbProductA: TIWLabel;
    lbPriceA: TIWLabel;
    cbA: TIWCheckBox;
    edQA: TIWEdit;
    IWListbox1: TIWListbox;
    IWComboBox1: TIWComboBox;
    IWLabel3: TIWLabel;
    btCheckout: TIWButton;
    lbProductB: TIWLabel;
    lbPriceB: TIWLabel;
    cbB: TIWCheckBox;
    edQB: TIWEdit;
    lbProductC: TIWLabel;
    lbPriceC: TIWLabel;
    cbC: TIWCheckBox;
    edQC: TIWEdit;
    TIWPayPalClient1: TTIWPayPalClient;
    lbDone: TIWLabel;
    IWLabel1: TIWLabel;
    lbProductD: TIWLabel;
    lbPriceD: TIWLabel;
    cbD: TIWCheckBox;
    edQD: TIWEdit;
    IWImageFile2: TIWImageFile;
    IWImageFile3: TIWImageFile;
    IWImageFile4: TIWImageFile;
    IWImageFile5: TIWImageFile;
    edUserName: TIWEdit;
    IWLabel7: TIWLabel;
    IWLabel9: TIWLabel;
    edPassword: TIWEdit;
    IWLabel2: TIWLabel;
    edSignature: TIWEdit;
    procedure IWAppFormCreate(Sender: TObject);
    procedure btCheckoutClick(Sender: TObject);
    procedure UpdateCart();
    procedure cbAAsyncChange(Sender: TObject; EventParams: TStringList);
    procedure TIWPayPalClient1PayPalPaymentOK(Sender: TObject);
    procedure TIWPayPalClient1PayPalCancel(Sender: TObject);
    procedure TIWPayPalClient1PayPalFailed(Sender: TObject);
  public
    APIUserName: string;
    APIPassword: string;
    APISignature: string;
  end;

implementation

{$R *.dfm}

function IsStrANumber(const S: string): Boolean;
begin
  Result := True;
  try
    StrToInt(S);
  except
    Result := False;
  end;
end;

procedure TIWForm10.UpdateCart();
var
  prtotal: integer;

  procedure AddItem(ProductName, Price, Quantity: string);
  begin
    if IsStrANumber(Quantity) then
    begin
      prtotal := StrToInt(Quantity) * StrToInt(StringReplace(Price, '$', '', [rfReplaceAll]));
      IWListbox1.Items.Add(ProductName + ': ' + Quantity + ' x ' + Price + ' = $' + IntToStr(prtotal));
    end;
  end;

begin
  IWListbox1.Clear;

  if cbA.Checked then
    AddItem(lbProductA.Text, lbPriceA.Text, edQA.Text);

  if cbB.Checked then
    AddItem(lbProductB.Text, lbPriceB.Text, edQB.Text);

  if cbC.Checked then
    AddItem(lbProductC.Text, lbPriceC.Text, edQC.Text);

  if cbD.Checked then
    AddItem(lbProductD.Text, lbPriceD.Text, edQD.Text);

  if IWListbox1.Items.Count > 0 then
    IWListbox1.Items.Add('Shipping: ' + IWComboBox1.Items[IWComboBox1.ItemIndex]);
end;

procedure TIWForm10.btCheckoutClick(Sender: TObject);
begin

  if edUserName.Text <> EmptyStr then
    TIWPayPalClient1.Seller.UserName := edUserName.Text;
  if edPassword.Text <> EmptyStr then
    TIWPayPalClient1.Seller.Password := edPassword.Text;
  if edSignature.Text <> EmptyStr then
    TIWPayPalClient1.Seller.Signature := edSignature.Text;

  if (TIWPayPalClient1.Seller.UserName = EmptyStr)
    or (TIWPayPalClient1.Seller.Password = EmptyStr)
    or (TIWPayPalClient1.Seller.Signature = EmptyStr) then
  begin
    WebApplication.ShowMessage('Please fill in your App ID and App Secret.');
    exit;
  end;

  TIWPayPalClient1.Transaction.Currency := crUSD;

  if IWComboBox1.ItemIndex = 1 then
    TIWPayPalClient1.Transaction.Shipping := 5
  else if IWComboBox1.ItemIndex = 2 then
    TIWPayPalClient1.Transaction.Shipping := 20;

  TIWPayPalClient1.Transactions.Clear;

  if cbA.Checked then
  begin
    with TIWPayPalClient1.Transactions.Add do
    begin
      Description := lbProductA.Text;
      Name := lbProductA.Text;
      Number := 1;
      Price := StrToFloat(StringReplace(lbPriceA.Text, '$', '', [rfReplaceAll]));
      Quantity := StrToInt(edQA.Text);
    end;
  end;

  if cbB.Checked then
  begin
    with TIWPayPalClient1.Transactions.Add do
    begin
      Description := lbProductB.Text;
      Name := lbProductB.Text;
      Number := 2;
      Price := StrToFloat(StringReplace(lbPriceB.Text, '$', '', [rfReplaceAll]));
      Quantity := StrToInt(edQB.Text);
    end;
  end;

  if cbC.Checked then
  begin
    with TIWPayPalClient1.Transactions.Add do
    begin
      Description := lbProductC.Text;
      Name := lbProductC.Text;
      Number := 3;
      Price := StrToFloat(StringReplace(lbPriceC.Text, '$', '', [rfReplaceAll]));
      Quantity := StrToInt(edQC.Text);
    end;
  end;

  if cbD.Checked then
  begin
    with TIWPayPalClient1.Transactions.Add do
    begin
      Description := lbProductD.Text;
      Name := lbProductD.Text;
      Number := 4;
      Price := StrToFloat(StringReplace(lbPriceD.Text, '$', '', [rfReplaceAll]));
      Quantity := StrToInt(edQD.Text);
    end;
  end;

  TIWPayPalClient1.PayOnline(WebApplication);
end;

procedure TIWForm10.cbAAsyncChange(Sender: TObject; EventParams: TStringList);
begin
  UpdateCart;
end;

procedure TIWForm10.IWAppFormCreate(Sender: TObject);
begin

  TIWPayPalClient1.ServerController := IWServerController.TIWAuthServerController1;
  TIWPayPalClient1.ServerType := stSandBox;

end;

procedure TIWForm10.TIWPayPalClient1PayPalCancel(Sender: TObject);
begin
  if TIWPayPalClient1.LoginResult = resFailed then
  begin
    lbDone.Visible := true;
    lbDone.Text := 'Payment canceled.';
  end;
end;

procedure TIWForm10.TIWPayPalClient1PayPalFailed(Sender: TObject);
begin
  if TIWPayPalClient1.LoginResult = resFailed then
  begin
    lbDone.Visible := true;
    lbDone.Text := 'Payment failed.';
  end;
end;

procedure TIWForm10.TIWPayPalClient1PayPalPaymentOK(Sender: TObject);
begin
  if TIWPayPalClient1.LoginResult = resOK then
  begin
    btCheckout.Visible := false;
    lbDone.Visible := true;
    lbDone.Text := 'Payment done!';
  end;
end;

initialization
  TIWForm10.SetAsMainForm;

end.
