// CodeGear C++Builder
// Copyright (c) 1995, 2012 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'IWPayPalClient.pas' rev: 24.00 (Win32)

#ifndef IwpaypalclientHPP
#define IwpaypalclientHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <Vcl.Controls.hpp>	// Pascal unit
#include <System.Classes.hpp>	// Pascal unit
#include <IWBaseControl.hpp>	// Pascal unit
#include <IWColor.hpp>	// Pascal unit
#include <IWControl.hpp>	// Pascal unit
#include <IWTypes.hpp>	// Pascal unit
#include <System.SysUtils.hpp>	// Pascal unit
#include <IWHTMLTag.hpp>	// Pascal unit
#include <Winapi.WinInet.hpp>	// Pascal unit
#include <Winapi.Windows.hpp>	// Pascal unit
#include <IWApplication.hpp>	// Pascal unit
#include <IWTMSAuthBase.hpp>	// Pascal unit
#include <Web.HTTPApp.hpp>	// Pascal unit
#include <System.Types.hpp>	// Pascal unit
#include <IW.HTTP.Request.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Iwpaypalclient
{
//-- type declarations -------------------------------------------------------
enum TIWCreditCardType : unsigned char { ctVisa, ctMasterCard, ctDiscover, ctAmericanExpress };

enum TIWCurrency : unsigned char { crEUR, crUSD, crAUD, crCAD, crGBP };

enum TIWServerType : unsigned char { stLive, stSandBox };

class DELPHICLASS TPayPalTransaction;
class DELPHICLASS TPayPalTransactions;
class PASCALIMPLEMENTATION TPayPalTransaction : public System::Classes::TCollectionItem
{
	typedef System::Classes::TCollectionItem inherited;
	
private:
	TPayPalTransactions* FOwner;
	System::UnicodeString FName;
	double FPrice;
	int FTag;
	int FQuantity;
	int FNumber;
	System::UnicodeString FDescription;
	void __fastcall SetDescription(const System::UnicodeString Value);
	void __fastcall SetNumber(const int Value);
	void __fastcall SetPrice(const double Value);
	void __fastcall SetQuantity(const int Value);
	
public:
	__fastcall virtual TPayPalTransaction(System::Classes::TCollection* Collection);
	__fastcall virtual ~TPayPalTransaction(void);
	virtual void __fastcall Assign(System::Classes::TPersistent* Source);
	DYNAMIC System::Classes::TPersistent* __fastcall GetOwner(void);
	
protected:
	virtual System::UnicodeString __fastcall GetDisplayName(void);
	
__published:
	__property System::UnicodeString Description = {read=FDescription, write=SetDescription};
	__property double Price = {read=FPrice, write=SetPrice};
	__property int Number = {read=FNumber, write=SetNumber, default=-1};
	__property int Quantity = {read=FQuantity, write=SetQuantity, default=1};
	__property System::UnicodeString Name = {read=FName, write=FName};
	__property int Tag = {read=FTag, write=FTag, default=0};
};


class DELPHICLASS TTIWPayPalClient;
#pragma pack(push,4)
class PASCALIMPLEMENTATION TPayPalTransactions : public System::Classes::TCollection
{
	typedef System::Classes::TCollection inherited;
	
public:
	TPayPalTransaction* operator[](int Index) { return Items[Index]; }
	
private:
	TTIWPayPalClient* FOwner;
	TPayPalTransaction* __fastcall GetItems(int Index);
	void __fastcall SetItems(int Index, TPayPalTransaction* const Value);
	
protected:
	virtual void __fastcall Update(System::Classes::TCollectionItem* Item);
	
public:
	__fastcall TPayPalTransactions(TTIWPayPalClient* AOwner);
	DYNAMIC System::Classes::TPersistent* __fastcall GetOwner(void);
	HIDESBASE TPayPalTransaction* __fastcall Add(void);
	HIDESBASE TPayPalTransaction* __fastcall Insert(int Index);
	__property TPayPalTransaction* Items[int Index] = {read=GetItems, write=SetItems/*, default*/};
public:
	/* TCollection.Destroy */ inline __fastcall virtual ~TPayPalTransactions(void) { }
	
};

#pragma pack(pop)

class DELPHICLASS TIWPayPalBuyer;
#pragma pack(push,4)
class PASCALIMPLEMENTATION TIWPayPalBuyer : public System::Classes::TPersistent
{
	typedef System::Classes::TPersistent inherited;
	
private:
	System::UnicodeString FEmail;
	System::UnicodeString FFirstName;
	System::UnicodeString FName;
	System::UnicodeString FStreet;
	System::UnicodeString FZip;
	System::UnicodeString FCity;
	System::UnicodeString FCountryCode;
	void __fastcall SetName(const System::UnicodeString Value);
	void __fastcall SetCity(const System::UnicodeString Value);
	void __fastcall SetCountryCode(const System::UnicodeString Value);
	void __fastcall SetEmail(const System::UnicodeString Value);
	void __fastcall SetFirstName(const System::UnicodeString Value);
	void __fastcall SetStreet(const System::UnicodeString Value);
	void __fastcall SetZip(const System::UnicodeString Value);
	
public:
	__fastcall TIWPayPalBuyer(void);
	
__published:
	__property System::UnicodeString Email = {read=FEmail, write=SetEmail};
	__property System::UnicodeString FirstName = {read=FFirstName, write=SetFirstName};
	__property System::UnicodeString Name = {read=FName, write=SetName};
	__property System::UnicodeString Street = {read=FStreet, write=SetStreet};
	__property System::UnicodeString Zip = {read=FZip, write=SetZip};
	__property System::UnicodeString City = {read=FCity, write=SetCity};
	__property System::UnicodeString CountryCode = {read=FCountryCode, write=SetCountryCode};
public:
	/* TPersistent.Destroy */ inline __fastcall virtual ~TIWPayPalBuyer(void) { }
	
};

#pragma pack(pop)

class DELPHICLASS TIWPayPalCreditCard;
#pragma pack(push,4)
class PASCALIMPLEMENTATION TIWPayPalCreditCard : public System::Classes::TPersistent
{
	typedef System::Classes::TPersistent inherited;
	
private:
	int FExpirationYear;
	int FExpirationMonth;
	TIWCreditCardType FCardType;
	System::UnicodeString FVerificationCode;
	System::UnicodeString FNumber;
	void __fastcall SetCardType(const TIWCreditCardType Value);
	void __fastcall SetExpirationMonth(const int Value);
	void __fastcall SetExpirationYear(const int Value);
	void __fastcall SetNumber(const System::UnicodeString Value);
	void __fastcall SetVerificationCode(const System::UnicodeString Value);
	
public:
	__fastcall TIWPayPalCreditCard(void);
	
__published:
	__property System::UnicodeString Number = {read=FNumber, write=SetNumber};
	__property TIWCreditCardType CardType = {read=FCardType, write=SetCardType, default=0};
	__property System::UnicodeString VerificationCode = {read=FVerificationCode, write=SetVerificationCode};
	__property int ExpirationMonth = {read=FExpirationMonth, write=SetExpirationMonth, nodefault};
	__property int ExpirationYear = {read=FExpirationYear, write=SetExpirationYear, nodefault};
public:
	/* TPersistent.Destroy */ inline __fastcall virtual ~TIWPayPalCreditCard(void) { }
	
};

#pragma pack(pop)

class DELPHICLASS TIWPayPalSeller;
#pragma pack(push,4)
class PASCALIMPLEMENTATION TIWPayPalSeller : public System::Classes::TPersistent
{
	typedef System::Classes::TPersistent inherited;
	
private:
	System::UnicodeString FSignature;
	System::UnicodeString FPassword;
	System::UnicodeString FUserName;
	void __fastcall SetPassword(const System::UnicodeString Value);
	void __fastcall SetSignature(const System::UnicodeString Value);
	void __fastcall SetUserName(const System::UnicodeString Value);
	
public:
	__fastcall TIWPayPalSeller(void);
	
__published:
	__property System::UnicodeString UserName = {read=FUserName, write=SetUserName};
	__property System::UnicodeString Password = {read=FPassword, write=SetPassword};
	__property System::UnicodeString Signature = {read=FSignature, write=SetSignature};
public:
	/* TPersistent.Destroy */ inline __fastcall virtual ~TIWPayPalSeller(void) { }
	
};

#pragma pack(pop)

class DELPHICLASS TIWPayPalTransaction;
class PASCALIMPLEMENTATION TIWPayPalTransaction : public System::Classes::TPersistent
{
	typedef System::Classes::TPersistent inherited;
	
private:
	double FInsurance;
	double FTax;
	double FShipping;
	TIWCurrency FCurrency;
	void __fastcall SetCurrency(const TIWCurrency Value);
	void __fastcall SetInsurance(const double Value);
	void __fastcall SetShipping(const double Value);
	void __fastcall SetTax(const double Value);
	
public:
	__fastcall TIWPayPalTransaction(void);
	
__published:
	__property TIWCurrency Currency = {read=FCurrency, write=SetCurrency, default=1};
	__property double Shipping = {read=FShipping, write=SetShipping};
	__property double Insurance = {read=FInsurance, write=SetInsurance};
	__property double Tax = {read=FTax, write=SetTax};
public:
	/* TPersistent.Destroy */ inline __fastcall virtual ~TIWPayPalTransaction(void) { }
	
};


class PASCALIMPLEMENTATION TTIWPayPalClient : public Iwtmsauthbase::TTIWCustomCloudClient
{
	typedef Iwtmsauthbase::TTIWCustomCloudClient inherited;
	
private:
	bool FDesignTime;
	System::UnicodeString FPaymentAction;
	TIWPayPalBuyer* FBuyer;
	TIWPayPalSeller* FSeller;
	TIWPayPalCreditCard* FCreditCard;
	TPayPalTransactions* FTransactions;
	System::Classes::TNotifyEvent FOnPayPalPaymentOK;
	System::Classes::TNotifyEvent FOnPayPalCancel;
	System::Classes::TNotifyEvent FOnPayPalFailed;
	TIWServerType FServerType;
	TIWPayPalTransaction* FTransaction;
	System::UnicodeString __fastcall GetCurrency(void);
	System::UnicodeString __fastcall GetCreditCardType(void);
	double __fastcall GetTotalPaymentAmount(void);
	
public:
	__fastcall virtual TTIWPayPalClient(System::Classes::TComponent* AOwner);
	__fastcall virtual ~TTIWPayPalClient(void);
	System::UnicodeString __fastcall GetServer(void);
	Iwtmsauthbase::TIWResult __fastcall PayDirect(void);
	Iwtmsauthbase::TIWResult __fastcall PayOnline(Iwapplication::TIWApplication* const WebApplication);
	virtual void __fastcall LoginResponse(Iw::Http::Request::THttpRequest* const Request);
	
__published:
	__property TIWPayPalBuyer* Buyer = {read=FBuyer, write=FBuyer};
	__property TIWPayPalCreditCard* CreditCard = {read=FCreditCard, write=FCreditCard};
	__property TIWPayPalSeller* Seller = {read=FSeller, write=FSeller};
	__property TIWServerType ServerType = {read=FServerType, write=FServerType, default=1};
	__property TIWPayPalTransaction* Transaction = {read=FTransaction, write=FTransaction};
	__property TPayPalTransactions* Transactions = {read=FTransactions, write=FTransactions};
	__property System::Classes::TNotifyEvent OnPayPalCancel = {read=FOnPayPalCancel, write=FOnPayPalCancel};
	__property System::Classes::TNotifyEvent OnPayPalFailed = {read=FOnPayPalFailed, write=FOnPayPalFailed};
	__property System::Classes::TNotifyEvent OnPayPalPaymentOK = {read=FOnPayPalPaymentOK, write=FOnPayPalPaymentOK};
};


//-- var, const, procedure ---------------------------------------------------
}	/* namespace Iwpaypalclient */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_IWPAYPALCLIENT)
using namespace Iwpaypalclient;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// IwpaypalclientHPP
